' module: play "Pairs"
declare function pairs(exercise as TExercise) as long
scope
  dim as TList pairsList
  with pairsList
    .listName = "pairs"
    .list.addAll(fullList.list)
    .load
    .save
    .list.clear
  end with
end scope
globalExercises.add(TExercise("Paare finden", "pairs", 0, @pairs, @infoEmpty, @chooseWords))

function pairs(exercise as TExercise) as long
  dim as integer W = 150, H = 60, Xstart = 50, Ystart = 100, Xplus = 180, yPlus = 100
  dim as integer card(3, 4), x, y, size, mx, my, mb, mb2, fontSize
  dim as string key, tempString
  dim as double timer_
  dim as mdList(TWord) words
  if exercise.currentList.size then
    words = randomWord(exercise.currentList, 10)
  else
    words = randomWord(exercise.fullList, 10)
  end if
  size = words.size
  dim as FB.Image ptr cardImg(20)
  dim as string tempTxt
  for i as integer = 1 to size
    do
      x = int(rnd*4)
      y = int(rnd*5)
    loop until card(x, y) = 0
    card(x, y) = i
    do
      x = int(rnd*4)
      y = int(rnd*5)
    loop until card(x, y) = 0
    card(x, y) = i+10
  next
  
  for i as integer = 0 to 20
    cardImg(i) = imagecreate(W, H)
    line cardImg(i), (0, 0)-(W-1, H-1), &hff000000, bf
    line cardImg(i), (3, 3)-(W-5, H-5), iif(i = 0, &hffffdf7f, &hffffffff), bf
    select case i
      case 0       : centerFT cardImg(i), "?", font, 24
      case 1 to 10
        tempString = words.get(i-1).word
        fontSize = iif(FTsize(tempString, font, 15).x > W - 10, 13, 15) 
        centerFT cardImg(i), tempString, font, fontSize
      case else
        tempString = words.get(i-11).translate.get(0)
        fontSize = iif(FTsize(tempString, font, 15).x > W - 10, 13, 15) 
        centerFT cardImg(i), tempString, font, fontSize
    end select
  next
  cls
  for x as integer = 0 to 3
    for y as integer = 0 to 4
      if card(x, y) > 0 then put (x*Xplus+Xstart, y*Yplus+Ystart), cardImg(0), pset
    next
  next

  do
    do
      getmouse mx, my,, mb
      sleep 1
    loop until mb = 0
    dim as integer x1 = -1, y1 = -1, x2 = -1, y2 = -1
    do
      key = inkey
      select case key
        case chr(27), chr(255, 107)
          exit do, do
        case chr(255, 59)
          dim as FB.Image ptr img = imagecreate(SCREEN_X, SCREEN_Y)
          get (0, 0)-step(SCREEN_X-1, SCREEN_Y-1), img
          help LANGUAGE & "/doc.htm", "pairs"
          put (0, 0), img, pset
          imagedestroy img
      end select
      for x as integer = 0 to 3
        for y as integer = 0 to 4
          if card(x, y) andalso checkMouseIn(x*Xplus+Xstart, y*Yplus+Ystart, W, H, 1) <> 0 then
            if x1 >= 0 andalso x1 = x and y1 = y then continue for
            if x1 >= 0 then
              x2 = x : y2 = y
            else
              x1 = x : y1 = y
            end if
            flipCard x*Xplus+Xstart, y*Yplus+Ystart, cardImg(0), cardImg(card(x, y))
            put (x*Xplus+Xstart, y*Yplus+Ystart), cardImg(card(x, y)), pset
            exit for, for
          end if
        next
      next
      sleep 1
    loop until x2 >= 0
    timer_ = timer
    mb = 1
    do
      key = inkey
      select case key
        case chr(255, 107)
          exit do, do
        case chr(27)
          if message("Wollen Sie abbrechen?", "Ja|Nein", 2) = 1 then exit do, do
        case chr(255, 59)
          dim as FB.Image ptr img = imagecreate(SCREEN_X, SCREEN_Y)
          get (0, 0)-step(SCREEN_X-1, SCREEN_Y-1), img
          help LANGUAGE & "/doc.htm", "pairs"
          put (0, 0), img, pset
          imagedestroy img
      end select
      getmouse mx, my,, mb2
      if (mb = 0 and mb2 > 0) or len(key) then exit do
      mb = mb2
      sleep 1
    loop until timer - timer_ > 1.5
    if abs(card(x1, y1) - card(x2, y2)) = 10 then
      flipCard x1*Xplus+Xstart, y1*Yplus+Ystart, cardImg(card(x1, y1))
      flipCard x2*Xplus+Xstart, y2*Yplus+Ystart, cardImg(card(x2, y2))
      card(x1, y1) = 0
      card(x2, y2) = 0
      size -= 1
    else
      flipCard x1*Xplus+Xstart, y1*Yplus+Ystart, cardImg(card(x1, y1)), cardImg(0)
      put (x1*Xplus+Xstart, y1*Yplus+Ystart), cardImg(0), pset
      flipCard x2*Xplus+Xstart, y2*Yplus+Ystart, cardImg(card(x2, y2)), cardImg(0)
      put (x2*Xplus+Xstart, y2*Yplus+Ystart), cardImg(0), pset
    end if
  loop until size = 0
  for i as integer = 0 to 20
    imagedestroy cardImg(i)
  next
  select case key
    case chr(255, 107) : return RETVAR.windowClosed
    case chr(27)       : return RETVAR.aborted
    case else          : return RETVAR.ok
  end select
end function
